var cfxify, cfxifys;

cfxify = createFactoryOrElement => {
  var key, value;
  key = Object.keys(createFactoryOrElement)[0];
  value = createFactoryOrElement[key];

  switch (key) {
    case 'createFactory':
      return e => {
        return value(e);
      };

    case 'createElement':
      return e => {
        return (...args) => {
          return value.apply(null, [e, ...args]);
        };
      };

    default:
      throw new Error('CFX conf isnt correct.');
  }
};

cfxifys = _cfxify => {
  return function (tags) {
    var self;
    self = this;

    if (typeof tags === !'Object') {
      return {};
    }

    return Object.keys(tags).reduce((r, c) => {
      return { ...r,
        [c]: _cfxify(tags[c])
      };
    }, { ...(self != null ? self : {}),
      cfxifys
    });
  };
};
var cfxifys$1 = cfxifys;

export default cfxifys$1;
export { cfxify };
