'use strict';

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cfxify = exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var cfxify, _cfxifys;
exports.cfxify = cfxify;
exports.cfxify = cfxify = function cfxify(createFactoryOrElement) {
  var key, value;
  key = Object.keys(createFactoryOrElement)[0];
  value = createFactoryOrElement[key];
  switch (key) {
    case 'createFactory':
      return function (e) {
        return value(e);
      };
    case 'createElement':
      return function (e) {
        return function () {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          return value.apply(null, [e].concat(args));
        };
      };
    default:
      throw new Error('CFX conf isnt correct.');
  }
};
_cfxifys = function cfxifys(_cfxify) {
  return function (tags) {
    var self;
    self = this;
    if ((0, _typeof2["default"])(tags) === !'Object') {
      return {};
    }
    return Object.keys(tags).reduce(function (r, c) {
      return _objectSpread({}, r, (0, _defineProperty2["default"])({}, c, _cfxify(tags[c])));
    }, _objectSpread({}, self != null ? self : {}, {
      cfxifys: _cfxifys
    }));
  };
};
var cfxifys$1 = _cfxifys;
var _default = cfxifys$1;
exports["default"] = _default;
